/* -*- mode: C++; coding: utf-8 -*- */
/*
 *
 *  HARK Middleware
 *  Copyright (C) 2013-2014 by Honda Research Institute Japan Co., Ltd.
 *
 *  $Id:$
 */

#include "libharkmw.h"
#include "object.h"

namespace HARKMW
{
    struct Object
    {
        PyObject_HEAD
        HARK::ObjectRef objectRef;
    };

    static void
    Object_dealloc(Object* self)
    {
//        self->objectRef.unref();
        Py_TYPE(self)->tp_free((PyObject*)self);
    }

    static PyObject *
    Object_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
    {
        Object *self;

        self = (Object *)type->tp_alloc(type, 0);
        if (self != NULL) {
//            self->object = NULL;
        }

        return (PyObject *)self;
    }

    static int
    Object_init(Object *self, PyObject *args, PyObject *kwds)
    {
        return 0;
    }

    static PyMethodDef Object_methods[] = {
        {NULL}  /* Sentinel */
    };

    static PyMemberDef Object_members[] = {
        {NULL}  /* Sentinel */
    };

    PyTypeObject ObjectType = {
        PyVarObject_HEAD_INIT(NULL, 0)
        "harkmwnative.Object",          /*tp_name*/
        sizeof(Object),             /*tp_basicsize*/
        0,                          /*tp_itemsize*/
        (destructor)Object_dealloc,             /*tp_dealloc*/
        0,                          /*tp_print*/
        0,                          /*tp_getattr*/
        0,                          /*tp_setattr*/
        0,                          /*tp_compare*/
        0,                          /*tp_repr*/
        0,                          /*tp_as_number*/
        0,                          /*tp_as_sequence*/
        0,                          /*tp_as_mapping*/
        0,                          /*tp_hash */
        0,                          /*tp_call*/
        0,                          /*tp_str*/
        0,                          /*tp_getattro*/
        0,                          /*tp_setattro*/
        0,                          /*tp_as_buffer*/
        Py_TPFLAGS_DEFAULT,         /*tp_flags*/
        "HARK::Object class wrapper", /* tp_doc */
        0,                            /* tp_traverse */
        0,                            /* tp_clear */
        0,                            /* tp_richcompare */
        0,                            /* tp_weaklistoffset */
        0,                            /* tp_iter */
        0,                            /* tp_iternext */
        Object_methods,             /* tp_methods */
        Object_members,             /* tp_members */
        0,                          /* tp_getset */
        0,                          /* tp_base */
        0,                          /* tp_dict */
        0,                          /* tp_descr_get */
        0,                          /* tp_descr_set */
        0,                          /* tp_dictoffset */
        (initproc)Object_init,      /* tp_init */
        0,                          /* tp_alloc */
        Object_new,                 /* tp_new */
    };

    PyObject *
    ObjectNew(HARK::ObjectRef &objectRef)
    {
        PyObject *p = PyType_GenericNew(&ObjectType, NULL, NULL);

        

        return p;
    }
}

/* end of file */
